<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningResult_v2 extends AbstractStructArrayBase
{
    /**
     * The PlanningResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningResult_v2[]
     */
    public $PlanningResult_v2;
    /**
     * Constructor method for ArrayOfPlanningResult_v2
     * @uses ArrayOfPlanningResult_v2::setPlanningResult_v2()
     * @param \StructType\PlanningResult_v2[] $planningResult_v2
     */
    public function __construct(array $planningResult_v2 = array())
    {
        $this
            ->setPlanningResult_v2($planningResult_v2);
    }
    /**
     * Get PlanningResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningResult_v2[]|null
     */
    public function getPlanningResult_v2()
    {
        return isset($this->PlanningResult_v2) ? $this->PlanningResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanningResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanningResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanningResult_v2ForArrayConstraintsFromSetPlanningResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanningResult_v2PlanningResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningResult_v2PlanningResult_v2Item instanceof \StructType\PlanningResult_v2) {
                $invalidValues[] = is_object($arrayOfPlanningResult_v2PlanningResult_v2Item) ? get_class($arrayOfPlanningResult_v2PlanningResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfPlanningResult_v2PlanningResult_v2Item), var_export($arrayOfPlanningResult_v2PlanningResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanningResult_v2 property can only contain items of type \StructType\PlanningResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanningResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningResult_v2[] $planningResult_v2
     * @return \ArrayType\ArrayOfPlanningResult_v2
     */
    public function setPlanningResult_v2(array $planningResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($planningResult_v2ArrayErrorMessage = self::validatePlanningResult_v2ForArrayConstraintsFromSetPlanningResult_v2($planningResult_v2))) {
            throw new \InvalidArgumentException($planningResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($planningResult_v2) || (is_array($planningResult_v2) && empty($planningResult_v2))) {
            unset($this->PlanningResult_v2);
        } else {
            $this->PlanningResult_v2 = $planningResult_v2;
        }
        return $this;
    }
    /**
     * Add item to PlanningResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningResult_v2 $item
     * @return \ArrayType\ArrayOfPlanningResult_v2
     */
    public function addToPlanningResult_v2(\StructType\PlanningResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningResult_v2) {
            throw new \InvalidArgumentException(sprintf('The PlanningResult_v2 property can only contain items of type \StructType\PlanningResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanningResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningResult_v2
     */
    public function getAttributeName()
    {
        return 'PlanningResult_v2';
    }
}
